/*
 *		GROSSE MACHINE POUR L'ANNEXE
 *
 *	https://povlab.online/animtutorial/anim17f-2.htm
 */

/* ------------------------------------------------------------ */

/* taille de la base */
#local SX_mac = 0.90;
#local SZ_mac = 4.80;

/* parametres du volant */
#local R_volant = 0.80;			// rayon

/* ============================================================ */

#declare Base_Machine_a = object
{
#local Sx = SX_mac + 0.09;
#local Sz = SZ_mac + 0.09;

box { <-Sx, 0, -Sz>, <Sx, H_trottoir, Sz> }

texture { TEINTE_BASIQUE }
}
/* ------------------------------------------------------------ */

#local Decoupe_a = object
{
cylinder { <-2, 0, 0>, <2, 0, 0>, 0.63  scale <1, 1, 1.717> }
}

#local Base_Machine_b = object
{
difference {
	box { <-SX_mac, 0, -SZ_mac>, <SX_mac, 0.75, SZ_mac> }
	#local Sx = SX_mac - 0.07;
	#local Sz = SZ_mac - 0.07;
	box { <-Sx, 0, -Sz>, <Sx, 0.70, Sz> }

	#local E = 2.8;
	object { Decoupe_a }
	object { Decoupe_a translate -E*z }
	object { Decoupe_a translate  E*z }
	}
texture { TEINTE_BASIQUE scale 5 }
}
/* ------------------------------------------------------------ */
#local Base_Machine = object
{
union	{
	object { Base_Machine_a }
	object { Base_Machine_b }
	}
}
/* ============================================================ */
/*
 *		la premiere partie mobile
 *		-------------------------
 *
 * 	https://povlab.online/animtutorial/anim17f-2.htm
 *
 */

#local C_radius    = R_volant * 0.88;		// position attache bielle/volant
#local C_Rod_Len   = 1.00;			// longueur de la bielle
#local Wheel_angle = clock * 1.666;		// angle rotation du volant

#local C_x =  C_radius * cos(radians(Wheel_angle));
#local C_y =  C_radius * sin(radians(Wheel_angle));
#local C_Rod_y = C_y;
#local C_Rod_x = sqrt(C_Rod_Len*C_Rod_Len-C_Rod_y*C_Rod_y);
#local C_Rod_Angle = degrees(atan2(C_Rod_y, C_Rod_x));

#local Volant_a = object
{
/*
 *	attention il est a plat sur le sol !
 */
union	{
	difference {
		cylinder { <0, -0.06, 0>, <0, 0.06, 0>, R_volant }
		cylinder { <0, -0.25, 0>, <0, 0.25, 0>, R_volant - 0.2 }
		}
	cylinder { <0, -0.24, 0>, <0, 0.06, 0>, 0.140 }		// moyeu

	/* attache de la bielle sur le volant */	
	cylinder { <0, -0.02, 0>, <0, 0.42, 0>, 0.055 translate <C_x, 0, C_y> }
	}
pigment { color Orange }
}

#local Un_Rayon = object
{
/* NEED MORE WORK */
box { <-0.775, -0.015, -0.075>, <0, 0.015, 0.075> }
pigment { color Green }
}

#local Rot_Angle = NormClock * 666.666;

#local Volant = object
{
union	{
	object { Volant_a 			}
	#for (foo, 0, 359, 51.4286)
	  object { Un_Rayon rotate y*foo 	}
	#end
	}
rotate y*C_Rod_Angle		// pour faire tourner le volant
rotate z*90			// pour redresser le volant
translate <0, 1.65, 0>
}

/* ============================================================ */

#local Bidon_a = object
{
merge	{
	sphere { 0, 0.27 }
	cylinder { <0, 0, 0>, <0, 0.65, 0>, 0.27 }
	sphere {  <0, 0.65, 0>, 0.27 }
	}
pigment { color Red }
translate <0, 1.70, 0>
}

#local Les_Bidons = object
{
union	{
	#local EB = 0.50;
	object { Bidon_a translate -x*EB }
	object { Bidon_a translate  x*EB }
	#undef EB
	}
}
/* ============================================================ */

#declare Grosse_Machine = object
{
union	{
	// object { Balise }
	object { Base_Machine	}

	object { Volant 	translate  z*3.00 }
	object { Les_Bidons	translate -z*1.42 }
	}
}
/* ============================================================ */
